commit 019f357fbd2df0594ad5c4fc70b5a66d2cfc4652
Author: jklowden <jklowden>
Date:   Thu Jun 12 03:10:16 2008 +0000

    Applied patch from Suren A. Chilingaryan cf.  ML on 10 June 2008

diff --git a/ChangeLog b/ChangeLog
index bfe1a42..7f6c7bb 100644
--- a/ChangeLog
+++ b/ChangeLog
@@ -1,3 +1,8 @@
+Wed Jun 11 23:07:29 EDT 2008	JK Lowden <jklowden@freetds.org>
+	* src/odbc/odbc.c src/odbc/unittests/getdata.c
+	- Applied patch from Suren A. Chilingaryan cf. 
+	- ML on 10 June 2008
+	
 Sat Jun  7 17:52:24 EDT 2008	JK Lowden <jklowden@freetds.org>
 	* src/dblib/dblib.c src/dblib/rpc.c src/dblib/unittests/rpc.c
 	* src/tds/convert.c
@@ -338,4 +343,4 @@ Wed Jan  9 19:54:43 EST 2008	JK Lowden <jklowden@freetds.org>
 	* ChangeLog  truncated because of release
 	* ChangeLog-0.82 added because of release
 	
-$Id: ChangeLog,v 1.2533 2008/06/12 01:00:48 jklowden Exp $
+$Id: ChangeLog,v 1.2534 2008/06/12 03:10:16 jklowden Exp $
diff --git a/src/odbc/odbc.c b/src/odbc/odbc.c
index a69da4f..07ab1ff 100644
--- a/src/odbc/odbc.c
+++ b/src/odbc/odbc.c
@@ -60,7 +60,7 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: odbc.c,v 1.481 2008/06/05 16:21:54 freddy77 Exp $");
+TDS_RCSID(var, "$Id: odbc.c,v 1.482 2008/06/12 03:10:16 jklowden Exp $");
 
 static SQLRETURN _SQLAllocConnect(SQLHENV henv, SQLHDBC FAR * phdbc);
 static SQLRETURN _SQLAllocEnv(SQLHENV FAR * phenv);
@@ -3707,29 +3707,32 @@ SQLRETURN ODBC_API
 SQLFetch(SQLHSTMT hstmt)
 {
 	SQLRETURN ret;
-	SQLULEN  save_sql_desc_array_size;
-	SQLULEN *save_sql_desc_rows_processed_ptr;
-	SQLUSMALLINT *save_sql_desc_array_status_ptr;
-
+	struct {
+		SQLULEN  array_size;
+		SQLULEN *rows_processed_ptr;
+		SQLUSMALLINT *array_status_ptr;
+	} keep;
+	
 	INIT_HSTMT;
 
 	tdsdump_log(TDS_DBG_FUNC, "SQLFetch(%p)\n", hstmt);
 
+	keep.array_size = stmt->ard->header.sql_desc_array_size;
+	keep.rows_processed_ptr = stmt->ird->header.sql_desc_rows_processed_ptr;
+	keep.array_status_ptr = stmt->ird->header.sql_desc_array_status_ptr;
+	
 	if (stmt->dbc->env->attr.odbc_version != SQL_OV_ODBC3) {
-		save_sql_desc_array_size = stmt->ard->header.sql_desc_array_size;
 		stmt->ard->header.sql_desc_array_size = 1;
-		save_sql_desc_rows_processed_ptr = stmt->ird->header.sql_desc_rows_processed_ptr;
 		stmt->ird->header.sql_desc_rows_processed_ptr = NULL;
-		save_sql_desc_array_status_ptr = stmt->ird->header.sql_desc_array_status_ptr;
 		stmt->ird->header.sql_desc_array_status_ptr = NULL;
 	}
 
 	ret = _SQLFetch(stmt, SQL_FETCH_NEXT, 0);
 
 	if (stmt->dbc->env->attr.odbc_version != SQL_OV_ODBC3) {
-		stmt->ard->header.sql_desc_array_size = save_sql_desc_array_size;
-		stmt->ird->header.sql_desc_rows_processed_ptr = save_sql_desc_rows_processed_ptr;
-		stmt->ird->header.sql_desc_array_status_ptr = save_sql_desc_array_status_ptr;
+		stmt->ard->header.sql_desc_array_size = keep.array_size;
+		stmt->ird->header.sql_desc_rows_processed_ptr = keep.rows_processed_ptr;
+		stmt->ird->header.sql_desc_array_status_ptr = keep.array_status_ptr;
 	}
 
 	ODBC_RETURN(stmt, ret);
@@ -4636,7 +4639,6 @@ SQLGetData(SQLHSTMT hstmt, SQLUSMALLINT icol, SQLSMALLINT fCType, SQLPOINTER rgb
 {
 	/* TODO cursors fetch row if needed ?? */
 	TDSCOLUMN *colinfo;
-	TDSRESULTINFO *resinfo;
 	TDSSOCKET *tds;
 	TDS_CHAR *src;
 	int srclen;
@@ -4644,6 +4646,8 @@ SQLGetData(SQLHSTMT hstmt, SQLUSMALLINT icol, SQLSMALLINT fCType, SQLPOINTER rgb
 	SQLLEN dummy_cb;
 	int nSybType;
 
+	int extra_bytes = 0;
+
 	INIT_HSTMT;
 
 	tdsdump_log(TDS_DBG_FUNC, "SQLGetData(%p, %u, %d, %p, %d, %p)\n", 
@@ -4684,42 +4688,140 @@ SQLGetData(SQLHSTMT hstmt, SQLUSMALLINT icol, SQLSMALLINT fCType, SQLPOINTER rgb
 	if (colinfo->column_cur_size < 0) {
 		*pcbValue = SQL_NULL_DATA;
 	} else {
+		nSybType = tds_get_conversion_type(colinfo->column_type, colinfo->column_size);
+		if (fCType == SQL_C_DEFAULT)
+			fCType = odbc_sql_to_c_type_default(stmt->ird->records[icol - 1].sql_desc_concise_type);
+		if (fCType == SQL_ARD_TYPE) {
+			if (icol > stmt->ard->header.sql_desc_count) {
+				odbc_errs_add(&stmt->errs, "07009", NULL);
+				ODBC_RETURN(stmt, SQL_ERROR);
+			}
+			fCType = stmt->ard->records[icol - 1].sql_desc_concise_type;
+		}
+		assert(fCType);
+
 		src = (TDS_CHAR *) colinfo->column_data;
 		if (is_variable_type(colinfo->column_type)) {
-			if (colinfo->column_text_sqlgetdatapos > 0
-			    && colinfo->column_text_sqlgetdatapos >= colinfo->column_cur_size)
-				ODBC_RETURN(stmt, SQL_NO_DATA);
-
+			int nread = 0;
+			
 			/* 2003-8-29 check for an old bug -- freddy77 */
 			assert(colinfo->column_text_sqlgetdatapos >= 0);
 			if (is_blob_type(colinfo->column_type))
 				src = ((TDSBLOB *) src)->textvalue;
-			src += colinfo->column_text_sqlgetdatapos;
-			srclen = colinfo->column_cur_size - colinfo->column_text_sqlgetdatapos;
+
+			if (fCType == SQL_C_CHAR && colinfo->column_text_sqlgetdatapos) {
+				TDS_CHAR buf[3];
+				SQLLEN len;
+
+				switch (nSybType) {
+				case SYBLONGBINARY:
+				case SYBBINARY:
+				case SYBVARBINARY:
+				case SYBIMAGE:
+				case XSYBBINARY:
+				case XSYBVARBINARY:
+				case TDS_CONVERT_BINARY:
+					if (colinfo->column_text_sqlgetdatapos % 2) {
+						nread = (colinfo->column_text_sqlgetdatapos - 1) / 2;
+						if (nread >= colinfo->column_cur_size)
+							ODBC_RETURN(stmt, SQL_NO_DATA);
+						
+						if (cbValueMax > 2) {
+							len = convert_tds2sql(context, nSybType, src + nread, 1, fCType, buf, sizeof(buf), NULL);
+							if (len < 2) {
+								if (len < 0) 
+									odbc_convert_err_set(&stmt->errs, len);
+								ODBC_RETURN(stmt, SQL_ERROR);
+							}
+							*(TDS_CHAR *) rgbValue = buf[1];
+							*((TDS_CHAR *) rgbValue + 1) = 0;
+						
+							rgbValue++;
+							cbValueMax--;
+						
+							extra_bytes = 1;
+							nread++;
+
+							if (nread >= colinfo->column_cur_size)
+								ODBC_RETURN_(stmt);
+						} else {
+							if (cbValueMax) 
+								*(TDS_CHAR *) rgbValue = 0;
+							odbc_errs_add(&stmt->errs, "01004", "String data, right truncated");
+							ODBC_RETURN(stmt, SQL_SUCCESS_WITH_INFO);
+						}
+					} else {
+						nread = colinfo->column_text_sqlgetdatapos / 2;
+						if (nread >= colinfo->column_cur_size)
+							ODBC_RETURN(stmt, SQL_NO_DATA);
+					}
+					
+					src += nread;
+					srclen = colinfo->column_cur_size - nread;
+					break;
+				default:
+					if (colinfo->column_text_sqlgetdatapos >= colinfo->column_cur_size)
+						ODBC_RETURN(stmt, SQL_NO_DATA);
+						
+					src += colinfo->column_text_sqlgetdatapos;
+					srclen = colinfo->column_cur_size - colinfo->column_text_sqlgetdatapos;
+
+				}
+			} else if (fCType == SQL_C_BINARY) {
+				switch (nSybType) {
+				case SYBCHAR:
+				case SYBVARCHAR:
+				case SYBTEXT:
+				case XSYBCHAR:
+				case XSYBVARCHAR:
+					nread = (src[0] == '0' && toupper(src[1]) == 'X')? 2 : 0;
+						
+					while ((nread < colinfo->column_cur_size) && (src[nread] == ' ' || src[nread] == '\0')) 
+						nread++;
+
+					nread += colinfo->column_text_sqlgetdatapos * 2;
+					
+					if (nread && nread >= colinfo->column_cur_size)
+						ODBC_RETURN(stmt, SQL_NO_DATA);
+
+					src += nread;
+					srclen = colinfo->column_cur_size - nread;
+					break;
+				default:
+					if (colinfo->column_text_sqlgetdatapos > 0
+					&&  colinfo->column_text_sqlgetdatapos >= colinfo->column_cur_size)
+						ODBC_RETURN(stmt, SQL_NO_DATA);
+						
+					src += colinfo->column_text_sqlgetdatapos;
+					srclen = colinfo->column_cur_size - colinfo->column_text_sqlgetdatapos;
+				}
+			} else {
+				if (colinfo->column_text_sqlgetdatapos > 0
+				&&  colinfo->column_text_sqlgetdatapos >= colinfo->column_cur_size)
+					ODBC_RETURN(stmt, SQL_NO_DATA);
+
+				src += colinfo->column_text_sqlgetdatapos;
+				srclen = colinfo->column_cur_size - colinfo->column_text_sqlgetdatapos;
+			}
 		} else {
 			if (colinfo->column_text_sqlgetdatapos > 0
-			    && colinfo->column_text_sqlgetdatapos >= colinfo->column_cur_size)
+			&&  colinfo->column_text_sqlgetdatapos >= colinfo->column_cur_size)
 				ODBC_RETURN(stmt, SQL_NO_DATA);
 
 			srclen = colinfo->column_cur_size;
 		}
-		nSybType = tds_get_conversion_type(colinfo->column_type, colinfo->column_size);
-		if (fCType == SQL_C_DEFAULT)
-			fCType = odbc_sql_to_c_type_default(stmt->ird->records[icol - 1].sql_desc_concise_type);
-		if (fCType == SQL_ARD_TYPE) {
-			if (icol > stmt->ard->header.sql_desc_count) {
-				odbc_errs_add(&stmt->errs, "07009", NULL);
-				ODBC_RETURN(stmt, SQL_ERROR);
-			}
-			fCType = stmt->ard->records[icol - 1].sql_desc_concise_type;
-		}
-		assert(fCType);
+
 		*pcbValue = convert_tds2sql(context, nSybType, src, srclen, fCType, (TDS_CHAR *) rgbValue, cbValueMax, NULL);
 		if (*pcbValue < 0) {
 			odbc_convert_err_set(&stmt->errs, *pcbValue);
 			ODBC_RETURN(stmt, SQL_ERROR);
 		}
-
+		
+		if (extra_bytes) {
+			colinfo->column_text_sqlgetdatapos += extra_bytes;
+			*pcbValue += extra_bytes;
+		}
+		
 		if (is_variable_type(colinfo->column_type) && (fCType == SQL_C_CHAR || fCType == SQL_C_BINARY)) {
 			/* calculate how many bytes were read */
 			int remaining = cbValueMax;
diff --git a/src/odbc/unittests/getdata.c b/src/odbc/unittests/getdata.c
index 8520ca1..f772605 100644
--- a/src/odbc/unittests/getdata.c
+++ b/src/odbc/unittests/getdata.c
@@ -1,6 +1,6 @@
 #include "common.h"
 
-static char software_version[] = "$Id: getdata.c,v 1.6 2008/01/29 14:30:48 freddy77 Exp $";
+static char software_version[] = "$Id: getdata.c,v 1.7 2008/06/12 03:10:16 jklowden Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
 static char odbc_err[256];
@@ -11,7 +11,14 @@ ReadError(void)
 {
 	memset(odbc_err, 0, sizeof(odbc_err));
 	memset(odbc_sqlstate, 0, sizeof(odbc_sqlstate));
-	if (!SQL_SUCCEEDED(SQLGetDiagRec(SQL_HANDLE_STMT, Statement, 1, (SQLCHAR *) odbc_sqlstate, NULL, (SQLCHAR *) odbc_err, sizeof(odbc_err), NULL))) {
+	if (!SQL_SUCCEEDED(SQLGetDiagRec(SQL_HANDLE_STMT
+					, Statement
+					, 1
+					, (SQLCHAR *) odbc_sqlstate
+					, NULL
+					, (SQLCHAR *) odbc_err
+					, sizeof(odbc_err)
+					, NULL))) {
 		printf("SQLGetDiagRec should not fail\n");
 		exit(1);
 	}

